/*

   Z----------------------------------Z
   |                                  |
   |    File Created By: Amir Tavafi  |
   |                                  |
   |    Date Created:    2009/11/30,  |
   |                     1388/08/09   |
   |                                  |
   Z----------------------------------Z

*/

#include <rcsc/player/soccer_action.h>
#include <rcsc/geom/vector_2d.h>

#include <vector>

namespace rcsc {
class WorldModel;
}

class Bhv_MarlikBlock
    : public rcsc::SoccerBehavior {
private:

public:  

  static bool isInBlockPoint;
  static int timeAtBlockPoint;
  static rcsc::Vector2D opp_static_pos;
  
    bool execute( rcsc::PlayerAgent * agent );
    bool execute2010( rcsc::PlayerAgent * agent );

private:


    bool doInterceptBall( rcsc::PlayerAgent * agent );
    bool doInterceptBall2011( rcsc::PlayerAgent * agent );

    bool doBlockMove( rcsc::PlayerAgent * agent );
    bool doBlockNear2012( rcsc::PlayerAgent * agent );
    
    rcsc::Vector2D getOppTarget( rcsc::PlayerAgent * agent, rcsc::Vector2D ball);
    rcsc::Vector2D getBlockPoint( rcsc::PlayerAgent * agent );
    rcsc::Vector2D getStopPoint( rcsc::PlayerAgent * agent );

    double getBlockDashPower( const rcsc::PlayerAgent * agent,
                              const rcsc::Vector2D & blockPos );
};
